Perspective Transform Batch
Perspective Transform

Details of the warp perspective operation are described above in the WarpPerspective section. More...

## Data Structures

struct | NppiWarpPerspectiveBatchCXR

## Functions

NppStatus | nppiWarpPerspectiveBatchInit (NppiWarpPerspectiveBatchCXR *pBatchList, unsigned int nBatchSize)
| Initializes the aTransformdedCoeffs array in pBatchList for each image in the list. More...
NppStatus | nppiWarpPerspectiveBatch_32f_C1R (NppiSize oSmallestSrcSize, NppiRect oSrcRectROI, NppiRect oDstRectROI, int eInterpolation, NppiWarpPerspectiveBatchCXR *pBatchList, unsigned int nBatchSize)
| 1 channel 32-bit floating point image warp perspective batch. More...
NppStatus | nppiWarpPerspectiveBatch_32f_C3R (NppiSize oSmallestSrcSize, NppiRect oSrcRectROI, NppiRect oDstRectROI, int eInterpolation, NppiWarpPerspectiveBatchCXR *pBatchList, unsigned int nBatchSize)
| 3 channel 32-bit floating point image warp perspective batch. More...
NppStatus | nppiWarpPerspectiveBatch_32f_C4R (NppiSize oSmallestSrcSize, NppiRect oSrcRectROI, NppiRect oDstRectROI, int eInterpolation, NppiWarpPerspectiveBatchCXR *pBatchList, unsigned int nBatchSize)
| 4 channel 32-bit floating point image warp perspective batch. More...
NppStatus | nppiWarpPerspectiveBatch_32f_AC4R (NppiSize oSmallestSrcSize, NppiRect oSrcRectROI, NppiRect oDstRectROI, int eInterpolation, NppiWarpPerspectiveBatchCXR *pBatchList, unsigned int nBatchSize)
| 4 channel 32-bit floating point image warp perspective batch not affecting alpha. More...

## Detailed Description

Details of the warp perspective operation are described above in the WarpPerspective section.

WarpPerspectiveBatch generally takes the same parameter list as WarpPerspective except that there is a list of N instances of those parameters (N > 1) and that list is passed in device memory. A convenient data structure is provided that allows for easy initialization of the parameter lists. The aTransformedCoeffs array is for internal use only and should not be directly initialized by the application. The only restriction on these functions is that there is one single source ROI rectangle and one single destination ROI rectangle which are applied respectively to each image in the batch. The primary purpose of this function is to provide improved performance for batches of smaller images as long as GPU resources are available. Therefore it is recommended that the function not be used for very large images as there may not be resources available for processing several large images simultaneously. A single set of oSrcRectROI and oDstRectROI values are applied to each source image and destination image in the batch. Source and destination image sizes may vary but oSmallestSrcSize must be set to the smallest source and image size in the batch. The parameters in the NppiWarpPerspectiveBatchCXR structure represent the corresponding per-image nppiWarpPerspective parameters for each image in the batch. The NppiWarpPerspectiveBatchCXR array must be in device memory. The nppiWarpPerspectiveBatchInit function MUST be called AFTER the application has initialized the array of NppiWarpPerspectiveBatchCXR structures and BEFORE calling any of the nppiWarpPerspectiveBatch functions to so that the aTransformedCoeffs array can be internally pre-initialized for each image in the batch. The batch size passed to nppiWarpPerspectiveBatchInit must match the batch size passed to the corresponding warp perspective batch function.

WarpPerspectiveBatch supports the following interpolation modes:

* NPPI_INTER_NN
* NPPI_INTER_LINEAR
* NPPI_INTER_CUBIC
*

# Codes

The warp perspective primitives return the following error codes:

        - ::NPP_RECTANGLE_ERROR if either destination ROI width or
          height is less than 1 pixel.
        - ::NPP_INTERPOLATION_ERROR if eInterpolation has an illegal value.
        - ::NPP_SIZE_ERROR if source size width or height is less than 2 pixels.

### Common parameters for nppiWarpPerspectiveBatch functions include:

Parameters

  oSmallestSrcSize | Size in pixels of the entire smallest source image width and height, may be from different images.
  oSrcRectROI | Region of interest in the source images.
  oDstRectROI | Region of interest in the destination images.
  eInterpolation | The type of eInterpolation to perform resampling. Currently limited to NPPI_INTER_NN, NPPI_INTER_LINEAR, or NPPI_INTER_CUBIC.
  pBatchList | Device memory pointer to nBatchSize list of NppiWarpPerspectiveBatchCXR structures.
  nBatchSize | Number of NppiWarpPerspectiveBatchCXR structures in this call (must be > 1).

Returns
  Image Data Related Error Codes, ROI Related Error Codes

## Function Documentation

NppStatus nppiWarpPerspectiveBatch_32f_AC4R | ( | NppiSize | oSmallestSrcSize,
|  | NppiRect | oSrcRectROI,
|  | NppiRect | oDstRectROI,
|  | int | eInterpolation,
|  | NppiWarpPerspectiveBatchCXR * | pBatchList,
|  | unsigned int | nBatchSize
| ) |  |

4 channel 32-bit floating point image warp perspective batch not affecting alpha.

For common parameter descriptions, see Common parameters for nppiWarpPerspectiveBatch functions.

NppStatus nppiWarpPerspectiveBatch_32f_C1R | ( | NppiSize | oSmallestSrcSize,
|  | NppiRect | oSrcRectROI,
|  | NppiRect | oDstRectROI,
|  | int | eInterpolation,
|  | NppiWarpPerspectiveBatchCXR * | pBatchList,
|  | unsigned int | nBatchSize
| ) |  |

1 channel 32-bit floating point image warp perspective batch.

For common parameter descriptions, see Common parameters for nppiWarpPerspectiveBatch functions.

NppStatus nppiWarpPerspectiveBatch_32f_C3R | ( | NppiSize | oSmallestSrcSize,
|  | NppiRect | oSrcRectROI,
|  | NppiRect | oDstRectROI,
|  | int | eInterpolation,
|  | NppiWarpPerspectiveBatchCXR * | pBatchList,
|  | unsigned int | nBatchSize
| ) |  |

3 channel 32-bit floating point image warp perspective batch.

For common parameter descriptions, see Common parameters for nppiWarpPerspectiveBatch functions.

NppStatus nppiWarpPerspectiveBatch_32f_C4R | ( | NppiSize | oSmallestSrcSize,
|  | NppiRect | oSrcRectROI,
|  | NppiRect | oDstRectROI,
|  | int | eInterpolation,
|  | NppiWarpPerspectiveBatchCXR * | pBatchList,
|  | unsigned int | nBatchSize
| ) |  |

4 channel 32-bit floating point image warp perspective batch.

For common parameter descriptions, see Common parameters for nppiWarpPerspectiveBatch functions.

NppStatus nppiWarpPerspectiveBatchInit | ( | NppiWarpPerspectiveBatchCXR * | pBatchList,
|  | unsigned int | nBatchSize
| ) |  |

Initializes the aTransformdedCoeffs array in pBatchList for each image in the list.

MUST be called before calling the corresponding warp perspective batch function whenever any of the transformation matrices in the list have changed.

Parameters

  pBatchList | Device memory pointer to nBatchSize list of NppiWarpPerspectiveBatchCXR structures.
  nBatchSize | Number of NppiWarpPerspectiveBatchCXR structures in this call (must be > 1).

Copyright © 2009-2017 NVIDIA Corporation